{% extends "base.html" %}
{% load i18n %}

{% block title %}{% translate "artefact types"|capfirst %}{% endblock %}

{% block javascript %}
    {{ block.super }}
    <!-- jsDelivr :: Sortable :: Latest (https://www.jsdelivr.com/package/npm/sortablejs) -->
    <script src="https://cdn.jsdelivr.net/npm/sortablejs@latest/Sortable.min.js"></script>
{% endblock javascript %}

{% block content %}
  <div class="row">
    <div class="col">
      <h1>{% translate "artefact types"|capfirst %}</h1>
    </div>
  </div>
  <div class="row">
    <div class="col text-end">
      {% if perms.artefacts.add_artefacttype %}
        <a id="addButton" href="{% url 'artefacts:add-type' %}" class="btn btn-outline-primary ">{% translate "add"|capfirst %}</a>
      {%  endif %}
    </div>
  </div>
  <div class="row justify-content-center">
    <div class="col">
      {% if object_list %}
      <table class="table table-hover">
        <thead class="thead-light">
          <tr>
            <th class="updateDisplay"></th>
            <th>{% translate "type name"|capfirst %}</th>
            <th>{% translate "description"|capfirst %}</th>
            <th></th>
          </tr>
        </thead>
        <tbody id="types">
          {% for type in object_list %}
          <tr data-lookup="{{ type.id }}">
            <td class="updateDisplay"><i class="handle bi bi-list"></i></td>
            <td>{{type.type_name}}</td>
            <td><i>{{type.description}}</i></td>
            <td>
              <div class="d-flex justify-content-end">
                {% if perms.artefacts.change_artefacttype %}
                  <a href="{% url 'artefacts:change-type' type.id %}" class="btn-sm btn-outline-primary mx-1"><i class="bi bi-pencil"></i></a>
                {%  endif %}
                {% if perms.artefacts.delete_artefacttype %}
                  <a href="{% url 'artefacts:delete-type' type.id %}" class="btn-sm btn-outline-danger mx-1"><i class="bi bi-trash"></i></a>
                {%  endif %}
              </div>
            </td>
          </tr>
          {% endfor %}
        </tbody>
      </table>
      {% else %}
      <p class="text-center">{% translate "no artefact types saved"|capfirst %}</p>
      {% endif %}
      <form id="orderingForm" method="post" action="{% url 'artefacts:save-type-ordering' %}">
        {% csrf_token %}
      <input type="hidden" id="orderingInput" name="ordering">
    </form>
    </div>
  </div>
  <div class="row">
    <div class="col text-end">
      {% if perms.artefacts.change_artefacttype %}
        <a id="reorderModeButton" class="btn btn-outline-primary" onclick="toggleReorderMode();">{% translate "reorder"|capfirst %}</a>
        <a id="cancelButton" href="{% url 'artefacts:list-type' %}" class="btn btn-outline-secondary me-2" onclick="toggleReorderMode();" style="display:none;"><i class="bi-x-lg"></i> {% translate "cancel"|capfirst %}</a>
        <button id="saveOrdering" class="btn btn-outline-primary" style="display:none;">{% translate "save"|capfirst %}</button>
      {%  endif %}
    </div>
  </div>

{% block inline_javascript %}
<script>

<!--ReorderModeScript-->
  let reorder_mode = false;

  function toggleReorderMode() {
    reorder_mode = !reorder_mode;
    updateDisplay();
  }

  function updateDisplay() {
    document.getElementById('reorderModeButton').style.display = reorder_mode ? 'none' : 'inline-block';
    document.getElementById('cancelButton').style.display = reorder_mode ? 'inline-block' : 'none';
    document.getElementById('saveOrdering').style.display = reorder_mode ? 'inline-block' : 'none';

    const hiddenStuff = document.querySelectorAll('.updateDisplay');
      for (let hidden of hiddenStuff) {
        if (reorder_mode) {
          hidden.style.display = '';
        } else {
          hidden.style.display = 'none';
        }
    }
  }

  document.addEventListener('DOMContentLoaded', () => {
    updateDisplay();
  });


<!--DragAndDropScript-->
  const types = document.getElementById("types");
  const saveOrderingButton = document.getElementById('saveOrdering');
  const orderingForm = document.getElementById('orderingForm');
  const formInput = orderingForm.querySelector('#orderingInput');

  let sortable = Sortable.create(types, {
    handle: '.handle',
    dragClass: 'dragged',
    chosenClass: 'sortableChosen',});

  function saveOrdering() {
    const rows = document.getElementById("types").querySelectorAll('tr');
    let ids = [];
    for (let row of rows) {
        ids.push(row.dataset.lookup);
    }
    formInput.value = ids.join(',');
    orderingForm.submit();
}

saveOrderingButton.addEventListener('click', saveOrdering);


</script>
{% endblock inline_javascript %}

{% endblock %}
